package com.safeway.epe.service;

import com.safeway.epe.config.ProducerServiceProxy;
import com.safeway.epe.domain.ConsumerPayload;
import com.safeway.epe.domain.Offsets;
import com.safeway.epe.domain.TransactionPayload;
import com.safeway.epe.domain.TransactionRecorder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import java.util.List;

@Component
public class ProducerService
{
    private Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private TransactionService transactionService;

    @Autowired
    private ProducerServiceProxy producerServiceProxy;

    public List<Offsets> produce(TransactionPayload request, String topic, TransactionRecorder transactionRecorder, boolean isReprocesed)
    {
        ResponseEntity<ConsumerPayload> response = producerServiceProxy.produceTransactionService(topic,request);
        logger.info("response ::" + response);

        if(response != null && (response.getStatusCodeValue() == 200 || response.getStatusCode().is2xxSuccessful()))
        {
            logger.info("Data is inserted to topic");
            return response.getBody().getOffsetsList();
        }
        else
        {
            transactionService.errorResponse(transactionRecorder, "failed to insert data to topic", false);
            logger.info("failed to insert data to topic");
            return response.getBody().getOffsetsList();
        }
    }

}
